function f_HXplot

Gas=1;%air
M=28.97;%[kg/kmol] - Molar mass of air
P=101325; %[Pa] - Atmospheric pressure
R=8314.41; %[J/kmol] - Universal Gas constant
g=9.81;%[m/s]
T=linspace(273.15-20,273.15+30,100);%[K] - Absolute temperature

for i=1:length(T)
    [Cp(i),Rho(i),Lambda(i),Mu(i)] = f_gasprop(T(i),Gas);
    %Cp [J/kgK]
    %Rho [kg/m^3]
    %Lambda [W/mK]
    %Mu [kg/ms] - dynamic viscosity
    
    if T(i)<=0
        psat(i)=610.5*exp(21.875*(T(i)-273.15)/(265.5+T(i)-273.15));
    else
        psat(i)=610.5*exp(17.269*(T(i)-273.15)/(237.3+T(i)-273.15));
    end
end

figure(1);
hold on;
plot(T-273.15,psat,'color','r');
for i=1:9
    plot(T-273.15,psat*0.1*i,'color','b');
end




function nf_HX(fi,T)
if T(i)<=0
    psat(i)=610.5*exp(21.875*(T-273.15)/(265.5+T(i)-273.15));
else
    psat(i)=610.5*exp(17.269*(T-273.15)/(237.3+T(i)-273.15));
end
