function varargout = HXproc(varargin)
% HXPROC MATLAB code for HXproc.fig
%      HXPROC, by itself, creates a new HXPROC or raises the existing
%      singleton*.
%
%      H = HXPROC returns the handle to a new HXPROC or the handle to
%      the existing singleton*.
%
%      HXPROC('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in HXPROC.M with the given input arguments.
%
%      HXPROC('Property','Value',...) creates a new HXPROC or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before HXproc_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to HXproc_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help HXproc

% Last Modified by GUIDE v2.5 06-Oct-2016 13:17:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @HXproc_OpeningFcn, ...
                   'gui_OutputFcn',  @HXproc_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before HXproc is made visible.
function HXproc_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to HXproc (see VARARGIN)


handles.toplot.tetea=NaN;
handles.toplot.pvap=NaN;
handles.toplot.plotair=0;
handles.toplot.tetasurf=NaN;
handles.toplot.plotsurf=0;

set(hObject,'name','HXproc - Simplified psychometric chart at 1 [atm]','numbertitle','off');
f_HXplot(handles);

% Choose default command line output for HXproc
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes HXproc wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = HXproc_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function fi_Callback(hObject, eventdata, handles)
% hObject    handle to fi (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fi as text
%        str2double(get(hObject,'String')) returns contents of fi as a double


% --- Executes during object creation, after setting all properties.
function fi_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fi (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function teta_Callback(hObject, eventdata, handles)
% hObject    handle to teta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of teta as text
%        str2double(get(hObject,'String')) returns contents of teta as a double


% --- Executes during object creation, after setting all properties.
function teta_CreateFcn(hObject, eventdata, handles)
% hObject    handle to teta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in show.
function show_Callback(hObject, eventdata, handles)
% hObject    handle to show (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%constants
Rd=461.5;%[J/kgK] specific gas constant of water
Rair=287;%[J/kgK] specific gas constant of air
p_atm=101325;%[Pa] atmospheric pressure
c_air=1005;%[J/kgK] specific heat capacity of dry air
c_vap=1650;%[J/kgK] specific heat capacity of water vapour
r=2500.38*1e3;%[J/kg] specific evaporation capacity of water

%get input
teta=str2double(get(handles.teta,'string'));%[C]
fi=str2double(get(handles.fi,'string'));%[-]

%saturation vapour pressure
if teta<=0
    psat=610.5*exp(21.875*(teta)/(265.5+teta));%[Pa]
else
    psat=610.5*exp(17.269*(teta)/(237.3+teta));%[Pa]
end
%actual vapour pressure
pvap=psat*fi;%[Pa]
%absolute moisture concentration
cv=1000*pvap/(Rd*(teta+273.15));%[g/m^3] moisture concentration
%density of dry air
rho_air=(p_atm)/(Rair*(teta+273.15));%[kg/m^3]
%density of moist air
rho_m=(p_atm-pvap)/(Rair*(teta+273.15))+...
    (pvap)/(Rd*(teta+273.15));%[kg/m^3]
%x specific humidity
%x=Cd/rho_air;%[g/kg dry air]
x=1000*0.622*pvap/(p_atm-pvap);
%h specific enthalpy
h=( c_air*teta + c_vap*(x/1000)*teta + r*(x/1000) )/1000;%[kJ/kg]
%calculate the wet bulb temperature
%twet=h
%dew point temperature calculation
% Buck, A. L. (1981), "New equations for computing vapor pressure and enhancement factor", J. Appl. Meteorol. 20: 15271532
if teta<=0 %for -40-0C <=0.05%
    a=6.1121;
    b=17.966;
    c=247.15;%[C]
else 
    a=6.1121;
    b=17.368;
    c=238.88;%[C]
end
%Martin Wanielista, Robert Kersten and Ron Eaglin. 1997. Hydrology Water Quantity and Quality Control. John Wiley & Sons. 2nd ed.
%{
    fi=0.5
    teta=20
%}
td=((fi)^(1/8))*(112+0.9*teta)+0.1*teta-112;
    

%http://www.schweizer-fn.de/lueftung/feuchte/feuchte.php
%Nhrungsformel zur Berechnung der Feuchtkugeltemperatur
%tw=-5.809+0.058*fi+0.697*tair+0.003*fi*tair   [%g and [C]

%http://journals.ametsoc.org/doi/pdf/10.1175/JAMC-D-11-0143.1
%Wet-Bulb Temperature from Relative Humidity and Air Temperature
%roland Stull, Manuscript received 14 July 2011, in final form 28 August 2011
RH=fi*100;
tm=teta*atan(0.151977*(RH+8.313659)^0.5)+...
    atan(teta+RH)-atan(RH-1.676331)+...
    0.00391838*(RH)^(3/2)*atan(0.023101*RH)-4.686035;



%display data
set(handles.psat,'string',num2str(psat));
set(handles.pvap,'string',num2str(pvap));
set(handles.cv,'string',num2str(cv));
set(handles.rho,'string',num2str(rho_air));
set(handles.rho_m,'string',num2str(rho_m));
set(handles.x,'string',num2str(x));
set(handles.h,'string',num2str(h));
set(handles.td,'string',num2str(td));
set(handles.tm,'string',num2str(tm));

%plot data
handles.toplot.teta=teta;
handles.toplot.pvap=pvap;
handles.toplot.plotair=1;
handles.toplot.plotsurf=0;
handles = f_HXplot(handles);
guidata(hObject, handles);


function psat_Callback(hObject, eventdata, handles)
% hObject    handle to psat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of psat as text
%        str2double(get(hObject,'String')) returns contents of psat as a double


% --- Executes during object creation, after setting all properties.
function psat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to psat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function pvap_Callback(hObject, eventdata, handles)
% hObject    handle to pvap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of pvap as text
%        str2double(get(hObject,'String')) returns contents of pvap as a double


% --- Executes during object creation, after setting all properties.
function pvap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pvap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cv_Callback(hObject, eventdata, handles)
% hObject    handle to cv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cv as text
%        str2double(get(hObject,'String')) returns contents of cv as a double


% --- Executes during object creation, after setting all properties.
function cv_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cv (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function rho_Callback(hObject, eventdata, handles)
% hObject    handle to rho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of rho as text
%        str2double(get(hObject,'String')) returns contents of rho as a double


% --- Executes during object creation, after setting all properties.
function rho_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rho (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function x_Callback(hObject, eventdata, handles)
% hObject    handle to x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of x as text
%        str2double(get(hObject,'String')) returns contents of x as a double


% --- Executes during object creation, after setting all properties.
function x_CreateFcn(hObject, eventdata, handles)
% hObject    handle to x (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function h_Callback(hObject, eventdata, handles)
% hObject    handle to h (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of h as text
%        str2double(get(hObject,'String')) returns contents of h as a double


% --- Executes during object creation, after setting all properties.
function h_CreateFcn(hObject, eventdata, handles)
% hObject    handle to h (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function rho_m_Callback(hObject, eventdata, handles)
% hObject    handle to rho_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of rho_m as text
%        str2double(get(hObject,'String')) returns contents of rho_m as a double


% --- Executes during object creation, after setting all properties.
function rho_m_CreateFcn(hObject, eventdata, handles)
% hObject    handle to rho_m (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function tm_Callback(hObject, eventdata, handles)
% hObject    handle to tm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of tm as text
%        str2double(get(hObject,'String')) returns contents of tm as a double


% --- Executes during object creation, after setting all properties.
function tm_CreateFcn(hObject, eventdata, handles)
% hObject    handle to tm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function td_Callback(hObject, eventdata, handles)
% hObject    handle to td (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of td as text
%        str2double(get(hObject,'String')) returns contents of td as a double


% --- Executes during object creation, after setting all properties.
function td_CreateFcn(hObject, eventdata, handles)
% hObject    handle to td (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_fisurf_Callback(hObject, eventdata, handles)
% hObject    handle to edit_fisurf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_fisurf as text
%        str2double(get(hObject,'String')) returns contents of edit_fisurf as a double


% --- Executes during object creation, after setting all properties.
function edit_fisurf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_fisurf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_tetasurf_Callback(hObject, eventdata, handles)
% hObject    handle to edit_tetasurf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_tetasurf as text
%        str2double(get(hObject,'String')) returns contents of edit_tetasurf as a double


% --- Executes during object creation, after setting all properties.
function edit_tetasurf_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_tetasurf (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_tetaext_Callback(hObject, eventdata, handles)
% hObject    handle to edit_tetaext (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_tetaext as text
%        str2double(get(hObject,'String')) returns contents of edit_tetaext as a double


% --- Executes during object creation, after setting all properties.
function edit_tetaext_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_tetaext (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_f_Callback(hObject, eventdata, handles)
% hObject    handle to edit_f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_f as text
%        str2double(get(hObject,'String')) returns contents of edit_f as a double


% --- Executes during object creation, after setting all properties.
function edit_f_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in push_updatesurface.
function push_updatesurface_Callback(hObject, eventdata, handles)
% hObject    handle to push_updatesurface (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%get the properties of the internal air
fi=str2double(get(handles.fi,'string'));
teta=str2double(get(handles.teta,'string'));
pvap=str2double(get(handles.pvap,'string'));
if isnan(pvap)
    h=errordlg('Error: internal air properties must be calculated first!','Error','modal');
    uiwait(h);
    return;
end

%get the properties from the surface panel
tetaext=str2double(get(handles.edit_tetaext,'string'));
f=str2double(get(handles.edit_f,'string'));
tetasurf=str2double(get(handles.edit_tetasurf,'string'));
if isnan(tetaext) || isnan(f)
    if isnan(tetasurf)
        h=errordlg('Error: Please give either teta_ext and f, or teta_surf!','Error','modal');
        uiwait(h);
        return;
    else
        %do nothing
    end
else
    tetasurf=tetaext+f*(teta-tetaext);
    set(handles.edit_tetasurf,'string',num2str(tetasurf));
end

%calculate
if isnan(tetaext)==0
    if tetasurf<=0
        psatext=610.5*exp(21.875*(tetaext)/(265.5+tetaext));%[Pa]
    else
        psatext=610.5*exp(17.269*(tetaext)/(237.3+tetaext));%[Pa]
    end
else
    psatext=NaN;
end
if tetasurf<=0
    psatsurf=610.5*exp(21.875*(tetasurf)/(265.5+tetasurf));%[Pa]
else
    psatsurf=610.5*exp(17.269*(tetasurf)/(237.3+tetasurf));%[Pa]
end
fisurf=min([pvap/psatsurf,1]);
set(handles.edit_fisurf,'string',num2str(fisurf));

%save 
handles.toplot.tetaext=tetaext;
handles.toplot.psatext=psatext;
handles.toplot.tetasurf=tetasurf;
handles.toplot.psatsurf=psatsurf;
handles.toplot.plotsurf=1;
%plot data
handles = f_HXplot(handles);
guidata(hObject, handles);




