close all;
clear all;
clc;

teta=linspace(-20,40,500);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%saturation vapour pressure
%[Pa]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for i=1:length(teta);
    if teta<=0
        psat(i)=610.5*exp(21.875*(teta(i))/(265.5+teta(i)));%[Pa]
    else
        psat(i)=610.5*exp(17.269*(teta(i))/(237.3+teta(i)));%[Pa]
    end
    result(i,1)=teta(i)+273.15;%[K]
    result(i,2)=psat(i);
end
dlmwrite('air_satpressure.csv',result,',');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%saturation moisture concentration
%[kg/m^3]
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Rd=461.5;%[J/kgK] specific gas constant of water
for i=1:length(teta);
   result2(i,1)=teta(i)+273.15;%[K]
   result2(i,2)=psat(i)/(Rd*(teta(i)+273.15));
end
dlmwrite('air_moistconc.csv',result2,',');








